#include <stdlib.h>

#include "./fib_lib.h"

int fib_slow(int n) {
  if (n == 0) {
    return 0;
  } else if (n == 1) {
    return 1;
  } else {
    return fib_slow(n - 1) + fib_slow(n - 2);
  }
}

int fib_fast(int n) {
  if (n >= 5000) {
    return fib_slow(n);
  }
  int cache[5000];
  cache[0] = 0;
  cache[1] = 1;
  for (int i = 2; i <= n; ++i) {
    cache[i] = cache[i - 1] + cache[i - 2];
  }
  return cache[n];
}
