#ifndef FIB_LIB_H
#define FIB_LIB_H

/* Compute the n-th fibonnaci number using the naive, exponential algorithm. */
int fib_slow(int n);

/* Compute the n-th fibonacci number using a linear algorithm based on the
   dynamic programming technique. */
int fib_fast(int n);

#endif /* FIB_LIB_H */
